// Copyright 2024 Bytedance Inc. All Rights Reserved.
// Author: tianlei.richard@qq.com (tianlei.richard)

#pragma once

#include <array>
#include <memory>

#include "common.h"
#include "triangle.h"

class Mesh {
public:
  Mesh(const std::vector<std::shared_ptr<Vertex>> &vertices,
       const std::vector<Triangle> &primitives);

  static std::vector<Mesh> load_mesh(const std::string &file_path);

public:
  Point2d get_texture_coordinate(const unsigned int index) const;
  Point3d get_normal_vector(const unsigned int index) const;
  std::vector<Triangle> &get_primitives() { return primitives_; };

private:
  std::vector<std::shared_ptr<Vertex>> vertices_;
  std::vector<Triangle> primitives_;
};
